#include <bits/stdc++.h>

using namespace std;

typedef vector<vector<int>> grid;
typedef pair<int, int> cell;

void prefix_sum_array(const grid& array, grid& prefix) {
    for(int i = 0; i < array.size(); i++) {
        prefix.push_back(vector<int>());
        for(int j = 0; j < array[i].size(); j++) {
            prefix[i].push_back(array[i][j] + 
                (i > 0 ? prefix[i-1][j] : 0) + 
                (j > 0 ? prefix[i][j-1] : 0) + 
                (i > 0 && j > 0 ? -prefix[i-1][j-1] : 0));
        }
    }
}

int sumq(const grid& prefix, cell a, cell b) {
    return prefix[b.first][b.second] - (a.second > 0 ? prefix[b.first][a.second-1] : 0)
        - (a.first > 0 ? prefix[a.first-1][b.second] : 0)
        + (a.first > 0 && a.second > 0 ? prefix[a.first-1][a.second-1] : 0);
}

int main() {
    grid array = {
        {3, 7, 9, 2, 7},
        {9, 8, 3, 5, 5},
        {1, 7, 9, 8, 5},
        {3, 8, 6, 4, 10},
        {6, 3, 9, 7, 8}
    };
    
    grid prefix;
    prefix_sum_array(array, prefix);
    
    cout << sumq(prefix, {1,2}, {3,3}) << endl;
    
    return 0;
}

